## osmium-tool 1.18.0

=== CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.10)

project(osmium VERSION 1.18.0 LANGUAGES CXX C)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")


#-----------------------------------------------------------------------------
#
#  Project version
#
#-----------------------------------------------------------------------------

# It is important that this setting remains before the "project" call.
set(CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo;MinSizeRel;Dev"
    CACHE STRING
    "List of available configuration types"
    FORCE)

set(AUTHOR "Jochen Topf <jochen@topf.org>")

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

option(WITH_LZ4 "Build with lz4 support for PBF files" ON)

option(BUILD_TESTING "Build the tests" ON)

# Some tests compare with binary files which might be different on your
# setup. Setting this to OFF disables those test.
# See https://github.com/osmcode/osmium-tool/issues/274
option(RUN_TESTS_WITH_BINARY_COMPARE "Run tests that do binary comparisons" ON)


#-----------------------------------------------------------------------------
#
#  Find external dependencies
#
#-----------------------------------------------------------------------------

find_package(Boost 1.55.0 REQUIRED COMPONENTS program_options)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})

find_package(Osmium 2.20.0 REQUIRED COMPONENTS io)
include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS})

find_package(nlohmann_json)

find_path(NLOHMANN_INCLUDE_DIR nlohmann/json.hpp)
include_directories(SYSTEM ${NLOHMANN_INCLUDE_DIR})

if(WITH_LZ4)
    find_package(LZ4)

    if(LZ4_FOUND)
        message(STATUS "lz4 library found, compiling with it")
        add_definitions(-DOSMIUM_WITH_LZ4)
        include_directories(SYSTEM ${LZ4_INCLUDE_DIRS})
        list(APPEND OSMIUM_LIBRARIES ${LZ4_LIBRARIES})
    else()
        message(WARNING "lz4 library not found, compiling without it")
    endif()
else()
    message(STATUS "Building without lz4 support: Set WITH_LZ4=ON to change this")
endif()


#-----------------------------------------------------------------------------
#
#  Optional "cppcheck" target that checks C++ code
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for cppcheck")
find_program(CPPCHECK cppcheck)

if(CPPCHECK)
    message(STATUS "Looking for cppcheck - found")
    set(CPPCHECK_OPTIONS --enable=warning,style,performance,portability,information,missingInclude)

    # cpp doesn't find system includes for some reason, suppress that report
    set(CPPCHECK_OPTIONS ${CPPCHECK_OPTIONS} --suppress=missingIncludeSystem)

    add_custom_target(cppcheck ${CPPCHECK} --std=c++14 ${CPPCHECK_OPTIONS} ${CMAKE_SOURCE_DIR}/src/*pp)
else()
    message(STATUS "Looking for cppcheck - not found")
    message(STATUS "  Build target 'cppcheck' will not be available")
endif()


#-----------------------------------------------------------------------------
#
#  Optional "iwyu" target to check headers
#  https://include-what-you-use.org/
#
#-----------------------------------------------------------------------------
find_program(IWYU_TOOL NAMES iwyu_tool iwyu_tool.py)

if(IWYU_TOOL)
    message(STATUS "Looking for iwyu_tool.py - found")
    add_custom_target(iwyu ${IWYU_TOOL} -p ${CMAKE_BINARY_DIR} -- --mapping_file=${CMAKE_SOURCE_DIR}/iwyu.imp)
else()
    message(STATUS "Looking for iwyu_tool.py - not found")
    message(STATUS "  Make target 'iwyu' will not be available")
endif()


#-----------------------------------------------------------------------------
#
#  Decide which C++ version to use (Minimum/default: C++14).
#
#-----------------------------------------------------------------------------
if(NOT MSVC)
    if(NOT USE_CPP_VERSION)
        set(USE_CPP_VERSION c++14)
    endif()
    message(STATUS "Use C++ version: ${USE_CPP_VERSION}")
    add_compile_options(-std=${USE_CPP_VERSION})
endif()


#-----------------------------------------------------------------------------
#
#  Compiler and Linker flags
#
#-----------------------------------------------------------------------------
if(MSVC)
    set(DEV_COMPILE_OPTIONS "/Ox")
    set(RWD_COMPILE_OPTIONS "/Ox /DNDEBUG")
else()
    set(DEV_COMPILE_OPTIONS "-O3 -g")
    set(RWD_COMPILE_OPTIONS "-O3 -g -DNDEBUG")
endif()

if(WIN32)
    add_definitions(-DWIN32 -D_WIN32 -DMSWIN32 -DBGDWIN32)
endif()

set(CMAKE_CXX_FLAGS_DEV "${DEV_COMPILE_OPTIONS}"
    CACHE STRING "Flags used by the compiler during developer builds."
    FORCE)

set(CMAKE_EXE_LINKER_FLAGS_DEV ""
    CACHE STRING "Flags used by the linker during developer builds."
    FORCE)
mark_as_advanced(
    CMAKE_CXX_FLAGS_DEV
    CMAKE_EXE_LINKER_FLAGS_DEV
)

set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${RWD_COMPILE_OPTIONS}"
    CACHE STRING "Flags used by the compiler during RELWITHDEBINFO builds."
    FORCE)


#-----------------------------------------------------------------------------
#
#  Build Type
#
#-----------------------------------------------------------------------------

add_definitions(${OSMIUM_WARNING_OPTIONS})

# In 'Dev' mode: compile with very strict warnings and turn them into errors.
if(CMAKE_BUILD_TYPE STREQUAL "Dev")
    if(NOT MSVC)
        add_definitions(-Werror)
    endif()
endif()

# Force RelWithDebInfo build type if none was given
if(CMAKE_BUILD_TYPE)
    set(build_type ${CMAKE_BUILD_TYPE})
else()
    set(build_type "RelWithDebInfo")
endif()

set(CMAKE_BUILD_TYPE ${build_type}
    CACHE STRING
    "Choose the type of build, options are: ${CMAKE_CONFIGURATION_TYPES}."
    FORCE)

message(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")


#-----------------------------------------------------------------------------
#
#  Version
#
#-----------------------------------------------------------------------------

find_package(Git)

if(GIT_FOUND)
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --tags --dirty=-changed
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                    OUTPUT_VARIABLE VERSION_FROM_GIT
                    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(VERSION_FROM_GIT)
        set(VERSION_FROM_GIT " (${VERSION_FROM_GIT})")
    endif()
endif()

configure_file(
    ${PROJECT_SOURCE_DIR}/src/version.cpp.in
    ${PROJECT_BINARY_DIR}/src/version.cpp
)

#-----------------------------------------------------------------------------

configure_file(
    ${PROJECT_SOURCE_DIR}/osmium-wrapper.in
    ${PROJECT_BINARY_DIR}/osmium
)

include_directories(SYSTEM include)
include_directories(${PROJECT_BINARY_DIR}/src)

#-----------------------------------------------------------------------------

SET(OSMIUM_COMMANDS
    add-locations-to-ways
    apply-changes
    cat
    changeset-filter
    check-refs
    create-locations-index
    derive-changes
    diff
    export
    extract
    fileinfo
    getid
    getparents
    merge
    merge-changes
    query-locations-index
    removeid
    renumber
    show
    sort
    tags-count
    tags-filter
    time-filter
)

set(OSMIUM_SOURCE_FILES
    cmd.cpp
    cmd_factory.cpp
    id_file.cpp
    io.cpp
    util.cpp
    command_help.cpp
    option_clean.cpp
    export/export_format_json.cpp
    export/export_format_pg.cpp
    export/export_format_text.cpp
    export/export_handler.cpp
    extract/extract_bbox.cpp
    extract/extract.cpp
    extract/extract_polygon.cpp
    extract/geojson_file_parser.cpp
    extract/geometry_util.cpp
    extract/osm_file_parser.cpp
    extract/poly_file_parser.cpp
    extract/strategy_complete_ways.cpp
    extract/strategy_complete_ways_with_history.cpp
    extract/strategy_simple.cpp
    extract/strategy_smart.cpp
)

foreach(_command ${OSMIUM_COMMANDS})
    string(REPLACE "-" "_" _ucmd ${_command})
    list(APPEND OSMIUM_SOURCE_FILES "command_${_ucmd}.cpp")
endforeach()

add_subdirectory(man)
add_subdirectory(src)


#-----------------------------------------------------------------------------
#
#  Tests
#
#-----------------------------------------------------------------------------

if(BUILD_TESTING)
    enable_testing()
    add_subdirectory(test)
endif()

#-----------------------------------------------------------------------------
#
#  Optional "clang-tidy" target
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for clang-tidy")
find_program(CLANG_TIDY NAMES clang-tidy clang-tidy-20 clang-tidy-19 clang-tidy-18 clang-tidy-17 clang-tidy-16 clang-tidy-15 clang-tidy-14)

if(CLANG_TIDY)
    message(STATUS "Looking for clang-tidy - found ${CLANG_TIDY}")

    file(GLOB _unit_tests RELATIVE "${CMAKE_SOURCE_DIR}/src" "${CMAKE_SOURCE_DIR}/test/*/*.cpp")

    add_custom_target(clang-tidy
        ${CLANG_TIDY}
        -p ${CMAKE_BINARY_DIR}
        ${OSMIUM_SOURCE_FILES} ${_unit_tests}
        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/src"
    )
else()
    message(STATUS "Looking for clang-tidy - not found")
    message(STATUS "  Build target 'clang-tidy' will not be available.")
endif()

#-----------------------------------------------------------------------------
#
#  Test install
#
#  Does a local install and checks that the files we expect to be installed
#  are installed and no extra files are installed. If this fails make sure
#  the list of files in cmake/test_install.cmake is correct. Only enables
#  if the WITH_EXTRA_TESTS option is set, because this test fails on some
#  platforms even if everything is correct.
#
#-----------------------------------------------------------------------------
option(WITH_EXTRA_TESTS "Run extra tests (usually only for developers)")
if(WITH_EXTRA_TESTS)
    add_test(NAME testinstall
             COMMAND ${CMAKE_COMMAND} -P ${CMAKE_SOURCE_DIR}/cmake/test_install.cmake)
endif()

#-----------------------------------------------------------------------------

=== test/check-refs/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - check-refs
#
#-----------------------------------------------------------------------------

add_test(NAME check-ref-w-okay COMMAND osmium check-refs ${CMAKE_SOURCE_DIR}/test/check-refs/okay.osm)
add_test(NAME check-ref-r-okay COMMAND osmium check-refs -r ${CMAKE_SOURCE_DIR}/test/check-refs/okay.osm)

add_test(NAME check-ref-fail-n-in-w COMMAND osmium check-refs ${CMAKE_SOURCE_DIR}/test/check-refs/fail-n-in-w.osm)
set_tests_properties(check-ref-fail-n-in-w PROPERTIES WILL_FAIL true)

add_test(NAME check-ref-w-way-okay COMMAND osmium check-refs    ${CMAKE_SOURCE_DIR}/test/check-refs/way-okay.osm)
add_test(NAME check-ref-r-way-okay COMMAND osmium check-refs -r ${CMAKE_SOURCE_DIR}/test/check-refs/way-okay.osm)
set_tests_properties(check-ref-r-way-okay PROPERTIES WILL_FAIL true)

add_test(NAME check-ref-okay-r-in-r COMMAND osmium check-refs -r ${CMAKE_SOURCE_DIR}/test/check-refs/okay-r-in-r.osm)

add_test(NAME check-ref-fail-n-in-r COMMAND osmium check-refs -r ${CMAKE_SOURCE_DIR}/test/check-refs/fail-n-in-r.osm)
set_tests_properties(check-ref-fail-n-in-r PROPERTIES WILL_FAIL true)

add_test(NAME check-ref-fail-w-in-r COMMAND osmium check-refs -r ${CMAKE_SOURCE_DIR}/test/check-refs/fail-w-in-r.osm)
set_tests_properties(check-ref-fail-w-in-r PROPERTIES WILL_FAIL true)

add_test(NAME check-ref-fail-r-in-r-1 COMMAND osmium check-refs -r ${CMAKE_SOURCE_DIR}/test/check-refs/fail-r-in-r-1.osm)
set_tests_properties(check-ref-fail-r-in-r-1 PROPERTIES WILL_FAIL true)

add_test(NAME check-ref-fail-r-in-r-2 COMMAND osmium check-refs -r ${CMAKE_SOURCE_DIR}/test/check-refs/fail-r-in-r-2.osm)
set_tests_properties(check-ref-fail-r-in-r-2 PROPERTIES WILL_FAIL true)

#-----------------------------------------------------------------------------

# input data not ordered properly

add_test(NAME check-ref-fail-order-n COMMAND osmium check-refs ${CMAKE_SOURCE_DIR}/test/order/fail-order-n.osm)
set_tests_properties(check-ref-fail-order-n PROPERTIES WILL_FAIL true)

add_test(NAME check-ref-fail-order-w COMMAND osmium check-refs ${CMAKE_SOURCE_DIR}/test/order/fail-order-w.osm)
set_tests_properties(check-ref-fail-order-w PROPERTIES WILL_FAIL true)

add_test(NAME check-ref-fail-order-r COMMAND osmium check-refs -r ${CMAKE_SOURCE_DIR}/test/order/fail-order-r.osm)
set_tests_properties(check-ref-fail-order-r PROPERTIES WILL_FAIL true)

add_test(NAME check-ref-fail-order-wn COMMAND osmium check-refs ${CMAKE_SOURCE_DIR}/test/order/fail-order-wn.osm)
set_tests_properties(check-ref-fail-order-wn PROPERTIES WILL_FAIL true)

add_test(NAME check-ref-fail-order-rw COMMAND osmium check-refs ${CMAKE_SOURCE_DIR}/test/order/fail-order-rw.osm)
set_tests_properties(check-ref-fail-order-rw PROPERTIES WILL_FAIL true)


#-----------------------------------------------------------------------------

=== test/diff/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - diff
#
#-----------------------------------------------------------------------------

function(check_diff _name _options _input1 _input2 _output _return_code)
    check_output(diff ${_name} "diff ${_options} diff/${_input1} diff/${_input2}" "diff/${_output}" "${_return_code}")
endfunction()

check_diff(compact "" input1.osm input2.osm output-compact 1)

check_diff(compact-c "-c" input1.osm input2.osm output-compact-c 1)

check_diff(opl "-f opl" input1.osm input2.osm output.opl 1)

check_diff(opl-c "-f opl -c" input1.osm input2.osm output-c.opl 1)

check_diff(same "" input1.osm input1.osm output-same 0)

check_diff(ignore-uid "--ignore-uid -c" input1.osm input2.osm output-compact-c-nouid 1)

check_diff(ignore-uid-15 "--ignore-uid -c" input1uid.osm input2uid.osm output-empty 0)

check_diff(ignore-uid-opl "--ignore-uid -f opl -c" input1.osm input2.osm output-compact-c-nouid-opl 1)

check_diff(ignore-uid-15-opl "--ignore-uid -f opl -c" input1uid.osm input2uid.osm output-empty 0)

#-----------------------------------------------------------------------------

=== test/export/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - export
#
#-----------------------------------------------------------------------------

function(check_export _name _options _input _output)
    check_output(export ${_name} "export ${_options} export/${_input}" "export/${_output}")
endfunction()

check_export(geojson    "-f geojson"       input.osm output.geojson)
check_export(geojsonmp  "-f geojson -u type_id" input-mp.osm output-mp.geojson)
check_export(geojsonseq "-f geojsonseq -x print_record_separator=false" input.osm output.geojsonseq)
check_export(geojsonuid "-f geojsonseq -u type_id" input.osm output-uid.geojsonseq)
check_export(geojsoncnt "-f geojsonseq -u counter" input.osm output-cnt.geojsonseq)
check_export(geojsonattr "-f geojson -n -a type,id,version,changeset,timestamp,uid,user,way_nodes" input.osm output-attr.geojson)
check_export(geojsonchar "-f geojson -n -a type,id,version,changeset,timestamp,uid,user,way_nodes" input-chars.osm output-chars.geojson)

check_export(pg         "-f pg"            input.osm output.pg)

check_export(missing-node "-f geojson" input-missing-node.osm output-missing-node.geojson)
check_export(single-node-way "-f geojson" input-single-node-way.osm output-empty.geojson)

add_test(NAME export-error-node COMMAND osmium export -f geojson -E ${CMAKE_SOURCE_DIR}/test/export/input-missing-node.osm)
set_tests_properties(export-error-node PROPERTIES WILL_FAIL true)

add_test(NAME export-error-single-node-way COMMAND osmium export -f geojson -E ${CMAKE_SOURCE_DIR}/test/export/input-single-node-way.osm)
set_tests_properties(export-error-single-node-way PROPERTIES WILL_FAIL true)

check_export(invalid-area "-f geojson"  input-incomplete-relation.osm output-incomplete-relation.geojson)

add_test(NAME export-error-area COMMAND osmium export -f geojson -E ${CMAKE_SOURCE_DIR}/test/export/input-incomplete-relation.osm)
set_tests_properties(export-error-area PROPERTIES WILL_FAIL true)

add_test(NAME export-error-incomplete-rel COMMAND osmium export -f geojson -E ${CMAKE_SOURCE_DIR}/test/export/input-incomplete-rel-missing-way.osm)
set_tests_properties(export-error-incomplete-rel PROPERTIES WILL_FAIL true)

#-----------------------------------------------------------------------------

check_export(attributes  "-E -f text -a id" way.osm way-all.txt)

check_export(c-empty-empty-n "-E -f text --keep-untagged -c export/config-empty-empty.json" way.osm way-all-n.txt)
set_tests_properties(export-c-empty-empty-n PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-empty-empty   "-E -f text                 -c export/config-empty-empty.json" way.osm way-all.txt)
set_tests_properties(export-c-empty-empty PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)

check_export(c-null-null  "-E -f text -c export/config-null-null.json" way.osm way-all.txt)
check_export(c-undefined  "-E -f text -c export/config-undefined.json" way.osm way-all.txt)

check_export(c-tag-empty  "-E -f text -c export/config-tag-empty.json" way.osm way-tag-empty.txt)
set_tests_properties(export-c-tag-empty PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-empty-tag  "-E -f text -c export/config-empty-tag.json" way.osm way-empty-tag.txt)
set_tests_properties(export-c-empty-tag PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-tag-tag    "-E -f text -c export/config-tag-tag.json"   way.osm way-tag-tag.txt)

check_export(c-tagx-empty "-E -f text -c export/config-tagx-empty.json" way.osm way-tagx-empty.txt)
set_tests_properties(export-c-tagx-empty PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-empty-tagx "-E -f text -c export/config-empty-tagx.json" way.osm way-empty-tagx.txt)
set_tests_properties(export-c-empty-tagx PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-tagx-tagx  "-E -f text -c export/config-tagx-tagx.json"  way.osm way-tagx-tagx.txt)

check_export(c-true-true   "-E -f text -c export/config-true-true.json"   way.osm way-all.txt)
check_export(c-false-false "-E -f text -c export/config-false-false.json" way.osm way-none.txt)

check_export(c-null-tag    "-E -f text -c export/config-null-tag.json" way.osm way-null-tag.txt)
check_export(c-tag-null    "-E -f text -c export/config-tag-null.json" way.osm way-tag-null.txt)

#-----------------------------------------------------------------------------

check_export(pg-untagged "-f pg --keep-untagged" input.osm output-untagged.pg)

#-----------------------------------------------------------------------------

=== test/extract/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - extract
#
#-----------------------------------------------------------------------------

function(check_extract _name _input _output _opts)
    check_output(extract ${_name} "extract --generator=test -f osm extract/${_input} ${_opts} -b 0,0,1.5,10" "extract/${_output}")
endfunction()

function(check_extract_cfg _name _input _output _opts)
    check_output(extract cfg_${_name} "extract --generator=test extract/${_input} ${_opts} -c ${CMAKE_CURRENT_SOURCE_DIR}/config.json" "extract/${_output}")
endfunction()

function(check_extract_opl _name _input _output _opts)
    check_output(extract ${_name} "extract --generator=test -f opl extract/${_input} ${_opts}" "extract/${_output}")
endfunction()


#-----------------------------------------------------------------------------

check_extract(clean                input1.osm output-clean.osm "--clean version --clean uid")

check_extract(simple               input1.osm output-simple.osm "-s simple --output-header=xml_josm_upload!")
check_extract(complete_ways        input1.osm output-complete-ways.osm "-s complete_ways")
check_extract(complete_ways_norels input1.osm output-complete-ways-norels.osm "-s complete_ways -S relations=false")
check_extract(smart_default        input1.osm output-smart.osm "-s smart")
check_extract(smart_mp             input1.osm output-smart.osm "-s smart -S types=multipolygon")
check_extract(smart_any            input1.osm output-smart.osm "-s smart -S types=any")
check_extract(smart_nonmp          input1.osm output-smart-nonmp.osm "-s smart -S types=x")

check_extract_cfg(simple           input1.osm output-simple.osm "-s simple --output-header=xml_josm_upload=false")

#-----------------------------------------------------------------------------

check_extract(clean64                input64.osm output-clean64.osm "--clean version --clean uid")

check_extract(simple64               input64.osm output-simple64.osm "-s simple --output-header=xml_josm_upload!")
check_extract(complete_ways64        input64.osm output-complete-ways64.osm "-s complete_ways")
check_extract(complete_ways_norels64 input64.osm output-complete-ways-norels64.osm "-s complete_ways -S relations=false")
check_extract(smart_default64        input64.osm output-smart64.osm "-s smart")
check_extract(smart_mp64             input64.osm output-smart64.osm "-s smart -S types=multipolygon")
check_extract(smart_any64            input64.osm output-smart64.osm "-s smart -S types=any")
check_extract(smart_nonmp64          input64.osm output-smart-nonmp64.osm "-s smart -S types=x")

check_extract_cfg(simple64           input64.osm output-simple64.osm "-s simple --output-header=xml_josm_upload=false")

#-----------------------------------------------------------------------------

check_extract_opl(antimeridian-east-bbox antimeridian.opl output-antimeridian-east.opl "--bbox=160,60,180,80")
check_extract_opl(antimeridian-west-bbox antimeridian.opl output-antimeridian-west.opl "--bbox=-180,60,-160,80")
check_extract_opl(antimeridian-east-poly antimeridian.opl output-antimeridian-east.opl "--polygon=extract/polygon-russia-east.geojson")
check_extract_opl(antimeridian-west-poly antimeridian.opl output-antimeridian-west.opl "--polygon=extract/polygon-russia-west.geojson")
check_extract_opl(antimeridian-both-poly antimeridian.opl output-antimeridian-both.opl "--polygon=extract/polygon-russia-all.geojson")
check_extract_opl(antimeridian-reverse-poly antimeridian.opl output-antimeridian-both.opl "--polygon=extract/polygon-russia-reverse.geojson")

check_extract_opl(antimeridian-alaska-east-json w42394837.osm w42394837.opl "--polygon=extract/polygon-us-alaska.geojson")
check_extract_opl(antimeridian-alaska-west-json w46113981.osm w46113981.opl "--polygon=extract/polygon-us-alaska.geojson")
check_extract_opl(antimeridian-alaska-east-poly w42394837.osm w42394837.opl "--polygon=extract/polygon-us-alaska.poly")
check_extract_opl(antimeridian-alaska-west-poly w46113981.osm w46113981.opl "--polygon=extract/polygon-us-alaska.poly")

check_extract_opl(antimeridian-alaska-east-json-no-feature w42394837.osm w42394837.opl "--polygon=extract/polygon-us-alaska-no-feature.geojson")

#-----------------------------------------------------------------------------

=== test/fileinfo/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - fileinfo
#
#-----------------------------------------------------------------------------

if(NOT WIN32)
    function(check_fileinfo _name _options _input _output)
        check_output(fileinfo ${_name} "fileinfo ${_options} fileinfo/${_input}" "fileinfo/${_output}")
    endfunction()

    check_fileinfo(fi1-extended "--extended --crc" fi1.osm fi1-result.txt)

    # Nlohmann JSON library before 3.9 don't have an ordered JSON type,
    # don't run tests that will not work because of that.
    if(nlohmann_json_VERSION VERSION_GREATER_EQUAL "3.9")
        check_fileinfo(fi1-extended-json "--extended --crc --json" fi1.osm fi1-result.json)
    endif()
endif()

#-----------------------------------------------------------------------------

add_test(NAME fileinfo-g-generator COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi1.osm -g header.option.generator)
set_tests_properties(fileinfo-g-generator PROPERTIES PASS_REGULAR_EXPRESSION "^testdata\n$")

add_test(NAME fileinfo-g-unknown-option COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi1.osm -g header.option.foo)
set_tests_properties(fileinfo-g-unknown-option PROPERTIES PASS_REGULAR_EXPRESSION "^$")

add_test(NAME fileinfo-g-fail COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi1.osm -g foobar)
set_tests_properties(fileinfo-g-fail PROPERTIES WILL_FAIL true)


#-----------------------------------------------------------------------------
# Test the metadata properties
#-----------------------------------------------------------------------------

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.all_objects.version
add_test(NAME fileinfo-metadata-mixed-all-version COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.all_objects.version)
set_tests_properties(fileinfo-metadata-mixed-all-version PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.all_objects.timestamp
add_test(NAME fileinfo-metadata-mixed-all-timestamp COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.all_objects.timestamp)
set_tests_properties(fileinfo-metadata-mixed-all-timestamp PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.all_objects.changeset
add_test(NAME fileinfo-metadata-mixed-all-changeset COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.all_objects.changeset)
set_tests_properties(fileinfo-metadata-mixed-all-changeset PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.version
add_test(NAME fileinfo-metadata-mixed-some-version COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.version)
set_tests_properties(fileinfo-metadata-mixed-some-version PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.timestamp
add_test(NAME fileinfo-metadata-mixed-some-timestamp COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.timestamp)
set_tests_properties(fileinfo-metadata-mixed-some-timestamp PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.changeset
add_test(NAME fileinfo-metadata-mixed-some-changeset COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.changeset)
set_tests_properties(fileinfo-metadata-mixed-some-changeset PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.uid
add_test(NAME fileinfo-metadata-mixed-some-uid COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.uid)
set_tests_properties(fileinfo-metadata-mixed-some-uid PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.user
add_test(NAME fileinfo-metadata-mixed-some-user COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.user)
set_tests_properties(fileinfo-metadata-mixed-some-user PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.version
add_test(NAME fileinfo-metadata-homogenous-all-version COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.version)
set_tests_properties(fileinfo-metadata-homogenous-all-version PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.timestamp
add_test(NAME fileinfo-metadata-homogenous-all-timestamp COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.timestamp)
set_tests_properties(fileinfo-metadata-homogenous-all-timestamp PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.changeset
add_test(NAME fileinfo-metadata-homogenous-all-changeset COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.changeset)
set_tests_properties(fileinfo-metadata-homogenous-all-changeset PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.uid
add_test(NAME fileinfo-metadata-homogenous-all-uid COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.uid)
set_tests_properties(fileinfo-metadata-homogenous-all-uid PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.user
add_test(NAME fileinfo-metadata-homogenous-all-user COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.user)
set_tests_properties(fileinfo-metadata-homogenous-all-user PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.version
add_test(NAME fileinfo-metadata-homogenous-some-version COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.version)
set_tests_properties(fileinfo-metadata-homogenous-some-version PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.timestamp
add_test(NAME fileinfo-metadata-homogenous-some-timestamp COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.timestamp)
set_tests_properties(fileinfo-metadata-homogenous-some-timestamp PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.changeset
add_test(NAME fileinfo-metadata-homogenous-some-changeset COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.changeset)
set_tests_properties(fileinfo-metadata-homogenous-some-changeset PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.uid
add_test(NAME fileinfo-metadata-homogenous-some-uid COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.uid)
set_tests_properties(fileinfo-metadata-homogenous-some-uid PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.user
add_test(NAME fileinfo-metadata-homogenous-some-user COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.user)
set_tests_properties(fileinfo-metadata-homogenous-some-user PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

#-----------------------------------------------------------------------------

=== test/getid/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - getid
#
#-----------------------------------------------------------------------------

function(check_getid _name _input _output)
    check_output(getid ${_name} "getid --generator=test --output-header=xml_josm_upload=false -f osm getid/${_input} n11,n12 w21" "getid/${_output}")
endfunction()

function(check_getid_file _name _file _input _output)
    check_output(getid ${_name} "getid --generator=test --output-header=xml_josm_upload=false -i getid/${_file} -f osm getid/${_input}" "getid/${_output}")
endfunction()

check_getid(n input.osm output.osm)
check_getid_file(file1 idfile input.osm output-file.osm)

#-----------------------------------------------------------------------------

function(check_getid_r _name _source _input _output)
    check_output(getid ${_name}   "getid -r --generator=test -f osm getid/${_source}.osm -I getid/${_input}.osm" "getid/${_output}.osm")
    check_output(getid ${_name}-i "getid -r --generator=test -f osm getid/${_source}.osm -i getid/${_input}.id"  "getid/${_output}.osm")
endfunction()

function(check_getid_r_fail _name _input)
    check_output(getid ${_name}   "getid -r --generator=test -f osm getid/source.osm -I getid/${_input}.osm" "getid/out-empty.osm" 1)
    check_output(getid ${_name}-i "getid -r --generator=test -f osm getid/source.osm -i getid/${_input}.id"  "getid/out-empty.osm" 1)
endfunction()

check_getid_r(n10 source in10 out10)
check_getid_r(w21 source in21 out21)
check_getid_r(r30 source in30 out30)
check_getid_r(r31 source in31 out31)
check_getid_r(r32 source in32 out32)

check_getid_r(n10nrr source-no-rr in10 out10)
check_getid_r(w21nrr source-no-rr in21 out21)
check_getid_r(r30nrr source-no-rr in30 out30)
check_getid_r(r32nrr source-no-rr in32 out32)

check_getid_r_fail(missing-n19 in19)
check_getid_r_fail(missing-w29 in29)
check_getid_r_fail(missing-r39 in39)

check_getid_r(relloop relloop relloop relloop-out)


#-----------------------------------------------------------------------------

=== test/getparents/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - getparents
#
#-----------------------------------------------------------------------------

function(check_getparents _name _input _ids _output)
    check_output(getparents ${_name} "getparents --generator=test --output-header=xml_josm_upload=false -f osm getparents/${_input} ${_ids}" "getparents/${_output}")
endfunction()

function(check_getparents_r _name _input _ids _output)
    check_output(getparents ${_name}-s "getparents --generator=test --output-header=xml_josm_upload=false -f osm --add-self getparents/${_input} ${_ids}" "getparents/${_output}")
endfunction()

#-----------------------------------------------------------------------------

check_getparents(n10 input.osm n10 out-n10.osm)
check_getparents(n12 input.osm n12 out-n12.osm)
check_getparents(w20 input.osm w20 out-w20.osm)

check_getparents_r(n10 input.osm n10 out-n10-s.osm)
check_getparents_r(n12 input.osm n12 out-n12-s.osm)
check_getparents_r(w20 input.osm w20 out-w20-s.osm)


#-----------------------------------------------------------------------------

=== test/misc/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - misc
#
#-----------------------------------------------------------------------------

do_test(version1 "osmium --version" "^osmium version ${PROJECT_VERSION}")
do_test(version2 "osmium version"   "^osmium version ${PROJECT_VERSION}")

do_test(unknown_command "osmium x" "^Unknown command or option 'x'. Try 'osmium help'.\n")


#-----------------------------------------------------------------------------

=== test/renumber/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - renumber
#
#-----------------------------------------------------------------------------

function(check_renumber _name _options _input _output)
    check_output(renumber ${_name} "renumber --generator=test ${_options} -f osm renumber/${_input}" "renumber/${_output}")
endfunction()

function(check_renumber2 _name _in1 _in2 _out)
    set(_idxdir "${PROJECT_BINARY_DIR}/test/renumber/index/${_name}")
    if(WIN32)
        set(_devnull "nul")
    else()
        set(_devnull "/dev/null")
    endif()
    check_output2(renumber ${_name} ${_idxdir}
                  "renumber --index-directory=${_idxdir} --generator=test -f osm --overwrite -o ${_devnull} renumber/${_in1}"
                  "renumber --index-directory=${_idxdir} --generator=test -f osc renumber/${_in2}"
                  "renumber/${_out}"
    )
endfunction()

check_renumber(sorted "" input-sorted.osm output-sorted.osm)
check_renumber(nodes-sorted "-t node" input-sorted.osm output-sorted-n.osm)
check_renumber(start-id-default "-s 1" input-sorted.osm output-sorted.osm)
check_renumber(start-ids "-s 0,3,-3" input-sorted.osm output-sorted-s.osm)

check_renumber2(change input-sorted.osm input-change.osc output-change.osc)

check_renumber2(change-norel input-norel.osm input-change.osc output-norel-change.osc)

#-----------------------------------------------------------------------------

# input data not ordered properly

add_test(NAME renumber-fail-order-n COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-n.osm -f osm)
set_tests_properties(renumber-fail-order-n PROPERTIES WILL_FAIL true)

add_test(NAME renumber-fail-order-w COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-w.osm -f osm)
set_tests_properties(renumber-fail-order-w PROPERTIES WILL_FAIL true)

add_test(NAME renumber-fail-order-r COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-r.osm -f osm)
set_tests_properties(renumber-fail-order-r PROPERTIES WILL_FAIL true)

add_test(NAME renumber-fail-order-wn COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-wn.osm -f osm)
set_tests_properties(renumber-fail-order-wn PROPERTIES WILL_FAIL true)

add_test(NAME renumber-fail-order-rw COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-rw.osm -f osm)
set_tests_properties(renumber-fail-order-rw PROPERTIES WILL_FAIL true)


#-----------------------------------------------------------------------------

=== test/sort/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - sort
#
#-----------------------------------------------------------------------------

function(check_sort2 _name _in1 _in2 _output)
    check_output(sort ${_name} "sort --generator=test -f osm sort/${_in1} sort/${_in2}" "sort/${_output}")
    check_output(sort ${_name}_mp "sort --generator=test -f osm -s multipass sort/${_in1} sort/${_in2}" "sort/${_output}")
endfunction()

function(check_sort1 _name _input _output _format)
    check_output(sort ${_name} "sort --generator=test -f ${_format} sort/${_input}" "sort/${_output}")
    check_output(sort ${_name}_mp "sort --generator=test -f ${_format} -s multipass sort/${_input}" "sort/${_output}")
endfunction()


#-----------------------------------------------------------------------------

check_sort2(simple input-simple1.osm input-simple2.osm output-simple.osm)
check_sort2(bounds input-bounds1.osm input-bounds2.osm output-bounds.osm)
check_sort2(history input-history1.osm input-history2.osm output-history.osm)

check_sort1(neg input-neg.osm output-neg.osm osm)
check_sort1(change input-change.osc output-change.osc osc)

# Tests with limited metadata
check_sort2(simple-1-only-version input-simple1-only-version.osm input-simple2.osm output-simple-1-only-version.osm)
check_sort1(mixed-metadata input-simple-onefile.osm output-simple-onefile.osm osm)
check_sort1(history-partially-only-version input-history-partially-only-version.osm output-history-partially-only-version.osm osm)
check_sort1(history-only-version input-history-only-version.osm output-history-only-version.osm osm)

#-----------------------------------------------------------------------------

=== test/time-filter/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - time-filter
#
#-----------------------------------------------------------------------------

function(check_time_filter _name _type _from _to _output)
    check_output(time-filter ${_name} "time-filter --generator=test --output-header=xml_josm_upload=false -f ${_type} time-filter/input.osh ${_from} ${_to}" "time-filter/output-${_output}.${_type}")
endfunction()

#-----------------------------------------------------------------------------

check_time_filter(last osm ""                   "" last)
check_time_filter(ts1  osm 2015-01-01T01:00:00Z "" ts1)
check_time_filter(ts1a osm 2015-01-01T01:01:00Z "" ts1)
check_time_filter(ts2  osm 2015-01-01T02:00:00Z "" ts2)
check_time_filter(ts2a osm 2015-01-01T02:01:00Z "" ts2)
check_time_filter(ts3  osm 2015-01-01T03:00:00Z "" ts3)
check_time_filter(ts3a osm 2015-01-01T03:01:00Z "" ts3)

check_time_filter(range-0-5   osh 2015-01-01T00:00:00Z 2015-01-01T05:00:00Z range-0-5)
check_time_filter(range-1-2   osh 2015-01-01T01:00:00Z 2015-01-01T02:00:00Z range-1-2)
check_time_filter(range-1a-2a osh 2015-01-01T01:01:00Z 2015-01-01T02:01:00Z range-1a-2a)
check_time_filter(range-2-3   osh 2015-01-01T02:00:00Z 2015-01-01T03:00:00Z range-2-3)
check_time_filter(range-2-3a  osh 2015-01-01T02:00:00Z 2015-01-01T03:01:00Z range-2-3a)
check_time_filter(range-2-4   osh 2015-01-01T02:00:00Z 2015-01-01T04:00:00Z range-2-4)


#-----------------------------------------------------------------------------

=== debian/changelog ===
osmium-tool (1.18.0-1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:08:34 +0200

osmium-tool (1.18.0-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:58:09 +0200

osmium-tool (1.18.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump minimum required libosmium2-dev to 2.22.0 for extract*64 tests.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 18 Mar 2025 05:27:24 +0100

=== debian/control ===
Source: osmium-tool
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: architecture-is-little-endian,
               debhelper-compat (= 13),
               cmake,
               libboost-dev,
               libboost-program-options-dev,
               libbz2-dev,
               libexpat1-dev,
               libosmium2-dev (>= 2.22.0),
               nlohmann-json3-dev,
               pandoc,
               zlib1g-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/osmium-tool/
Vcs-Git: https://salsa.debian.org/debian-gis-team/osmium-tool.git
Homepage: https://osmcode.org/osmium-tool/
Rules-Requires-Root: no

Package: osmium-tool
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Command line tool for working with OpenStreetMap data
 Osmium Tool is a multipurpose command line tool based on the Osmium library.
 .
 With the Osmium Tool you currently can:
 .
  * Get information about an OSM file
  * Convert OSM files from one format into another (supports all XML and PBF
    formats)
  * Merge and apply change files to an OSM file (with or without history)
  * Extract data from OSM history files for a given point in time or a time
    range
 .
 The Osmium library has extensive support for all types of OSM entities: nodes,
 ways, relations, and changesets. It allows reading from and writing to OSM
 files in XML and PBF formats, including change files and full history files.
 Osmium can store OSM data in memory and on disk in various formats and using
 various indexes. Its easy to use handler interface allows you to quickly write
 data filtering and conversion functions. Osmium can create WKT, WKB, OGR, GEOS
 and GeoJSON geometries for easy conversion into many GIS formats and it can
 assemble multipolygons from ways and relations.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Remove buildpath from binaries
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

# Verbose make output
export VERBOSE=1

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_VERBOSE_MAKEFILE=1

override_dh_auto_test:
# Ignore test failures on problematic architectures only
ifneq (,$(filter $(DEB_BUILD_ARCH),mips mips64el mipsel))
	dh_auto_test || echo "Ignoring test failures"
else
	dh_auto_test
endif

override_dh_installchangelogs:
	dh_installchangelogs -k CHANGELOG.md
